import './bce-element-icons';
import { EventEmitter } from '../../stencil.core';
import { Block } from '../../models/block';
import { ElementAction } from '../../models/element-action';
import { ElementQuestion } from '../../models/element-question';
import { ElementLabels } from '../../models/labels';
import { ResolveLocation } from '../../models/resolve-location';
export declare class BceElement {
    private el;
    type: Block.Type;
    value?: any;
    template: Block.Element | string;
    elementAction: ElementAction[];
    elementQuestion: ElementQuestion[];
    editor: boolean;
    hasFocus: boolean;
    name: string;
    elementIcon: string;
    readonly?: boolean;
    labels: ElementLabels;
    resolveLocation?: ResolveLocation;
    onTemplate: EventEmitter<Block.Element>;
    onDelete: EventEmitter;
    onDuplicate: EventEmitter;
    private handleFocus;
    private handleInput;
    private handleTemplate;
    private handleBlur;
    private handleDelete;
    private handleDuplicate;
    componentWillLoad(): void;
    parseValue(value: Block.Element | string): void;
    renderElement(): any;
    renderAction(action: ElementAction): any;
    renderExtra(question: ElementQuestion): any;
    renderTemplate(): any[];
    render(): any;
}
